<?php
/**
 * Tis file is part of XNova:Legacies
 *
 * @license http://www.gnu.org/licenses/gpl-3.0.txt
 * @see http://www.xnova-ng.org/
 *
 * Copyright (c) 2009-Present, XNova Support Team <http://www.xnova-ng.org>
 * All rights reserved.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *                                --> NOTICE <--
 *  This file is part of the core development branch, changing its contents will
 * make you unable to use the automatic updates manager. Please refer to the
 * documentation for further information about customizing XNova.
 *
 */

define('INSIDE' , true);
define('INSTALL' , false);
define('IN_ADMIN', true);
require_once dirname(dirname(__FILE__)) .'/common.php';

ini_set('display_errors', true);

include(ROOT_PATH . 'includes/functions/BBcodeFunction.' . PHPEXT);

includeLang('admin/mass_message');

class MassMessage
{	
	public $LangMo = NULL;
	
	public function __construct($EnabledBBcode, $CurrentUserId, $CurrentUserName, $Lang)
	{
		$this->LangMo = $Lang;
		
		if (isset($_POST['send']))
		{
			$Subject = mysql_real_escape_string($_POST['subject_text']);
			
			if ($EnabledBBcode == TRUE)
				$Message = trim(nl2br(bbcode(image(strip_tags(mysql_real_escape_string($_POST['message_text'])))), '<br />'));
			else
				$Message = trim(nl2br(strip_tags(mysql_real_escape_string($_POST['message_text'])), '<br />'));
			
			$Group = array();
			
			if (isset($_POST['c_administrators']))
				$Group[] = '3';
			if (isset($_POST['c_moderators']))
				$Group[] = '2';
			if (isset($_POST['c_operators']))
				$Group[] = '1';
			if (isset($_POST['c_members']))
				$Group[] = '0';
			
			$this->SendMessage($CurrentUserId, $CurrentUserName, $Subject, $Message, $Group);
		}
		else
		{
			$this->DisplayForm();
		}
	}
	
	public function SendMessage($Id, $Username, $Subject, $Message, $Group)
	{
		$Id = intval($Id);
		$Username = mysql_real_escape_string($Username);
		
		if 	(empty($Group))
			$Conditions = "";
		else			
			$Conditions = "WHERE `authlevel` IN (" . implode(",", $Group) . ")";
			
		$Query = <<<SQL
INSERT INTO {{table}}messages (`message_owner`, `message_sender`, `message_time`, `message_from`, `message_type`, `message_subject`, `message_text`)
SELECT 		`id`, '{$Id}', UNIX_TIMESTAMP(NOW()), '{$Username}', '100', '{$Subject}', '{$Message}' 
FROM 		{{table}}users 
{$Conditions}
SQL;
		doquery($Query, '');
			
		$Query = <<<SQL
UPDATE 	{{table}} 
SET 	`new_message` = `new_message` + '1' 
{$Conditions}
SQL;
		doquery($Query, 'users');
			
		message($this->LangMo['message_sended_text'], $this->LangMo['message_sended_title']);	
	}
	
	public function DisplayForm()
	{
		$page = parsetemplate(gettemplate('admin/mass_message'), $this->LangMo);
		display($page, $this->LangMo['PageTitle'], false, '', true);
	}
}

new MassMessage($game_config['enable_bbcode'], $user['id'], $user['username'], $lang);